#include "hmbdc/app/Client.hpp"
#include "hmbdc/app/LoggerT.hpp"
#include "hmbdc/Exception.hpp"
#include "hmbdc/os/Thread.hpp"

namespace hmbdc { namespace app { namespace utils {

using namespace hmbdc::app;

struct changeSched
: Client<changeSched> 
, hmbdc::app::detail::single_thread_powered_client {
	/*virtual*/ 
	void 
	messageDispatchingStartedCb(uint16_t threadSerialNumber) override {
        hmbdc::os::setCurrrentThreadSched(policy_, priority_);
        throw hmbdc::ExitCode(0);
    };
    /*virtual*/ 
    bool droppedCb() override {
    	delete this;
    	return true;
    };

    static
	auto& to(char const* policy, int priority) {
		return *new changeSched(policy, priority);
	}

private:
	changeSched(char const* policy, int priority)
	: policy_(policy)
	, priority_(priority) 
	{}

	char const* policy_;
	int priority_;

};



}}}
