#include "hmbdc/Copyright.hpp"
#pragma once
#include "hmbdc/text/TypedString.hpp"
#include <string>

namespace hmbdc { namespace comm {

extern char const TOPIC[];
/**
 * @brief topic as in the publish / subscribe communication paradigm
 * @details recommended allowed letters are [a-z] [A-Z] [0-9] and /
 * it has a length limit of 64 char
 */
struct Topic : hmbdc::text::TypedString<TOPIC, 64u> {
	/**
	 * @brief construct an empty topic
	 */
	Topic()
	: TypedString()
	{}
	
	/**
	 * @brief ctor from a char* string
	 * @details truncated to be 64 char
	 * 
	 * @param t topic string limited to 64 char
	 */
	Topic(char const* t)
	: TypedString(t)
	{}

    /**
     * @brief ctor from a std string
     * @details truncated to be 64 char
     * 
     * @param t topic string limited to 64 char
     */
	Topic(std::string t)
	: TypedString(t)
	{}
};
}}
