#include "hmbdc/Copyright.hpp"
#pragma once

#include "hmbdc/Exception.hpp"

#include <string>

namespace hmbdc { namespace comm { namespace inet {

using namespace std;
/**
 * @brief resolve a local ip interface using a mask
 * 
 * @param mask in this format: "192.168.0.1/24" or "192.168.0.101" which is the same as "192.168.0.101/32"
 * when using 192.168.0.1/0
 * @param includeLoopback if it is false, the loopback address is excluded from the result
 * @return a local ip matches the mask if no exception is thrown
 */
string getLocalIpMatchMask(string const& mask, bool includeLoopback = true);
string getLocalIpThruName(string const& name);
}}}
